unit test6f;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, SPIs, StdCtrls, ExtCtrls, ExtDlgs;

type
  TSPIsForm = class(TForm)
    SPIs1: TSPIs;
    ScrollBox1: TScrollBox;
    Img: TImage;
    Button1: TButton;
    OpenPicDlg: TOpenPictureDialog;
    NkCBox: TCheckBox;
    FsCBox: TCheckBox;
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  SPIsForm: TSPIsForm;

implementation

{$R *.dfm}

uses
  spibmp,spinkdib;

const
  captionstr='SPIs test';

procedure TSPIsForm.Button1Click(Sender: TObject);
var
  i,j : integer;
  ext,filter,all : string;
  bmp : TSPIBitmap;
  dib : TSPINkDIB;
  fs : TFileStream;
begin
  filter:= ''; all:='';
  for i := 0 to SPIs1.Count - 1 do begin
    if NOT (Spis1.Plugins[i] is TInSPI) then continue;
    for j:=0 to SPIs1.Plugins[i].ExtNames.Count-1 do begin
      ext:=SPIs1.Plugins[i].ExtNames[j];
      if filter='' then begin
        filter:=copy(ext,3,length(ext)-2)+' files|'+ext;
        all:='all files|'+ext;
      end else begin
        filter:=filter+'|'+copy(ext,3,length(ext)-2)+' files|'+ext;
        all:=all+';'+ext;
      end;
    end;
  end;
  OpenPicDlg.Filter:=all+'|'+filter;
  if OpenPicDlg.Execute(handle) then begin
    if NkCBox.Checked then begin
      // TSPINkDIB̃eXg
      dib:=TSPINkDIB.Create;
      try
        if FsCBox.Checked then begin
          fs:=TFileStream.Create(OpenPicDlg.FileName,fmOpenRead);
          try
            dib.LoadFromStream(fs);
          finally
            fs.free;
          end;
        end else
          dib.LoadFromFile(OpenPicDlg.Filename);
        Img.Picture.Assign(nil);
        Img.Width:=dib.Width; Img.Height:=dib.Height;
        Img.Picture.assign(dib);
      finally
        dib.free;
      end;
    end else begin
      // TSPIBitmap̃eXg
      bmp:=TSPIBitmap.Create;
      try
        if FsCBox.Checked then begin
          fs:=TFileStream.Create(OpenPicDlg.FileName,fmOpenRead);
          try
            bmp.LoadFromStream(fs);
          finally
            fs.free;
          end;
        end else
          bmp.LoadFromFile(OpenPicDlg.Filename);
        Img.Picture.Assign(nil);
        Img.Width:=bmp.Width; Img.Height:=bmp.Height;
        Img.Picture.assign(bmp);
      finally
        bmp.free;
      end;
    end;
    { ʂ͂
    img.picture.LoadFromFile(OpenPicDlg.Filename);
    img.Width:=img.Picture.Width;
    img.height:=img.Picture.Height;
    }
    caption:=captionstr+' - '+ExtractFilename(OpenPicDlg.FileName);
  end;
end;

end.
